/*
 * Copyright (c) 1991-1994  Sony Corporation
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the
 * "Software"), to deal in the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL SONY CORPORATION BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 * OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * Except as contained in this notice, the name of Sony Corporation
 * shall not be used in advertising or otherwise to promote the sale, use
 * or other dealings in this Software without prior written authorization
 * from Sony Corporation.
 *
 */

/*
 * $SonyRCSfile: connect.c,v $  
 * $SonyRevision: 1.1 $ 
 * $SonyDate: 1994/06/03 08:01:34 $
 */



#include "sj_rename.h"
#include "sj_typedef.h"
#include "sj_connect.h"
#include "sj_right.h"

static	u_char	mizen1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_o+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_o+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	mizen2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_o+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mizen3[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_o+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_o+ne2_o+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mizen4[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_o+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mizen5[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_o+seru_o+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_o+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	arou[] = {
		wo_x+ttatte_o +ttara_o +tte1_o +tte2_x +ppanasi_x +ppoi_x +ue_x,
		uti_x +oite_x +okeru_x +ori_x +ka1_x +ka2_o +kai_x +kasira_o,
		katagata_x+kadouka_x+kana_o+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_x+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_o+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_o+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	you1[] = {
		wo_x+ttatte_o +ttara_o +tte1_o +tte2_x +ppanasi_x +ppoi_x +ue_x,
		uti_x +oite_x +okeru_x +ori_x +ka1_x +ka2_o +kai_x +kasira_o,
		katagata_x+kadouka_x+kana_o+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_o+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_o+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	karou[] = {	
		wo_x+ttatte_o +ttara_x +tte1_o +tte2_x +ppanasi_x +ppoi_x +ue_x,
		uti_x +oite_x +okeru_x +ori_x +ka1_x +ka2_o +kai_x +kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		

static	u_char	darou[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_o+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_x+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	deshou[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_x+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_o+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ko[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_o+zaru_x+zu_x+zunba_o+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_o+reru_o+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	bekara[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_o+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tagara[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_x+seru_o+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	si1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_o+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_o+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_o+kaneru_o,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_o+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ji[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_o+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_o+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_o+zaru_o+zu_o+zunba_o+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_x+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_o+kaneru_o,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_x+dekiru_x+naru_x+nasai_o+nasaru_o+nikui_o,
		yasui_o+yoi_o+yaru_x+ttarasii_x
	};
		
static	u_char	age[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_o+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_o+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_o+zunba_o+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	i[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_o+zaru_o+zu_o+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_x+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_o+nasaru_o+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	e[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_o+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_o+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kake[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_o+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kane2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_o+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sugi[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_o+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_o+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_x+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	deki[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_o+zunba_o+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mi[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_o+zaru_x+zu_o+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sase[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_o+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_o+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	rare[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_o+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_o+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	itadake[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_o+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_o+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	exp[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_o,
		doori_x+dokoro_x+dokoroka_x+domo_o+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_o+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_o+zaru_o+zu_o+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	renyou1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_o+ppoi_o+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_o+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_o+zaru_o+zu_o+zunba_o+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_o+reru_o+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_o+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	renyou3[] = {
		wo_x+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_o+ppoi_o+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_o+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_o+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_o+nagara2_o+wo_s_o, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_o+zaru_o+zu_o+zunba_o+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_o+you_o+youda_x+rasii_o+rareru_o+reru_o+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_o+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	renyou4[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_o+ppoi_o+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_o+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_o+zaru_o+zu_o+zunba_o+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_o+tagaru_o+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_o+itadaku_o+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_o+gozai_x+sa1_o+si1_o+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_o+se_o+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_o+naru_x+nasai_o+nasaru_o+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	renyou5[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_o+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_o+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_o+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	renyou7[] = {
		wo_x+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_o+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_o+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_o+wo_s_o, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_o+tagaru_o+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_o+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	renyou8[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_o+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_o+tagaru_o+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_o+itadaku_o+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_o+gozai_x+sa1_x+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_o+naru_x+nasai_o+nasaru_x+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sa5renyou1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_o+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_o+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sa5renyou3[] = {
		wo_x+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_o+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_o+nagara2_o+wo_s_o, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sa5renyou4[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_o+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_o+tagaru_o+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_o+itadaku_o+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_o+gozai_x+sa1_o+si1_o+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_o+se_o+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_o+naru_x+nasai_o+nasaru_x+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	krenyou[] = {
		wo_x+ttatte_o+ttara_x+tte1_x+tte2_o+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_o+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_o+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_o+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	drenyou1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_o+ari2_x+ari3_x+are1_o+are2_x,
		arou_o+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_o+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	drenyou2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_o+okeru_o+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_o+tuki_o+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_o,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_o+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_o+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_o+naru_o+nasai_o+nasaru_o+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	drenyou3[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_o+naru_o+nasai_o+nasaru_o+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	onbin1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		

static	u_char	onbin2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	onbin3[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_o+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_o+da2_x+daxtu_x,
		darou_o+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_o+jimau_o+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	deshi[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_o+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	axtu[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_o+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	onbin6[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	onbin8[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_o+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ari1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_o+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_o+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_o+nasaru_o+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ari2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_o+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ari3[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_o+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	iki[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	itasi[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	itadaki[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_o+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ori2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	gataku[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_o+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_o+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_o+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_o+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ki[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	fzkki[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	deha[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	kudasai[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_o+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	gozai[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_o+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	gotoku[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	beku[] = {	
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	soude[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_x+ari3_o+are1_x+are2_o,
		arou_o+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	souni[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tagari[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	taku[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_o+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_o+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_o+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	de[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_o+ari2_x+ari3_x+are1_o+are2_x,
		arou_o+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_o+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	naide[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_o+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_o+iru_o+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_o+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	naku[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_o+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_o+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nasai[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	fuuni[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_o+kane_o+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_o+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_o+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	yori2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	rashuu[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_o+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	dshuusi1[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_o+kana_x+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_x+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_o+wake_x,
		wane_o+wayo_o+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_o+kke_o+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	dshuusi2[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	gotosi[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	besi[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	zu[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	souda[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_o+kana_x+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_x+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_o+wake_x,
		wane_o+wayo_o+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mai[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mitaida[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_x+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_o+wake_x,
		wane_o+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	shuusi[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_o+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_o+kuseni_o+kurai_o+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_o+sae_x+si2_o+sika_o+sura_x+zutu_x+zo_o,
		tame_o+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_o,
		te1_x+te2_x+teru_x+dearou_o+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_o+toki_o+tokoro_o+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_o+nominrz_o+ha_x+hazu_o+ba_x+bakari_o+he_x+hou_o,
		hoka_o+hodo_o+made_o+mama_o+mo1_o+mo2_x+motte_x+mono_o,
		ya1_x+ya2_o+yara_o+yue_o+yo_o+yori_o+wa_o+wake_o,
		wane_o+wayo_o+nn1_o+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_o+kke_x+n_si_x+deha_o,
		
		gotosi_o+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_x+desi_x+desho_o+desu_x+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_o+mai_o+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kshuusi[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_o+kurai_o+gurumi_x+kedo_o+koso_o,
		koto_o+sa2_o+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_o+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_o,
		te1_x+te2_x+teru_x+dearou_o+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_o+tokoro_o+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_x+no1_x+no2_o+node_o+noni_o,
		nomi_o+nominrz_o+ha_x+hazu_o+ba_x+bakari_o+he_x+hou_o,
		hoka_o+hodo_o+made_o+mama_o+mo1_o+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_o+wake_o,
		wane_o+wayo_o+nn1_o+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_o+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_x+desi_o+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	zaru[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_o+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_o+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_o+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_o+tokoro_o+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_o+hodo_x+made_o+mama_o+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_o+yo_x+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	soudesu[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_x+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_o+wake_x,
		wane_o+wayo_o+nn1_o+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ta[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_o+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_o+kuseni_o+kurai_o+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_o+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_o+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_o,
		te1_x+te2_x+teru_x+dearou_o+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_o+tokoro_o+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_o+nominrz_o+ha_x+hazu_o+ba_x+bakari_o+he_x+hou_o,
		hoka_o+hodo_o+made_o+mama_o+mo1_o+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_o+wake_o,
		wane_o+wayo_o+nn1_o+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_o+kke_o+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_x+desi_x+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tai[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_o+kurai_o+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_o+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_o+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_o+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_o+tokoro_o+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_o+ba_x+bakari_o+he_x+hou_o,
		hoka_o+hodo_o+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_o+wake_o,
		wane_o+wayo_o+nn1_o+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_x+desi_x+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	desu[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_x+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_o+yue_o+yo_o+yori_x+wa_o+wake_x,
		wane_o+wayo_x+nn1_o+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nai[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_o+kurai_o+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_o+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_o+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_o,
		te1_x+te2_x+teru_x+dearou_o+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_o+tokoro_o+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_o+ba_x+bakari_o+he_x+hou_o,
		hoka_o+hodo_o+made_o+mama_o+mo1_o+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_o+wake_o,
		wane_o+wayo_o+nn1_o+jya_o+tya_x+nagara2_o+wo_s_x, 
		ze_o+kke_o+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_x+desi_x+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nu[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_o+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_o+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_o+yue_o+yo_x+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_x+desi_x+desho_x+desu_x+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_o+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	masu[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_o+ka1_x+ka2_o+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_o+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_o+hodo_o+made_o+mama_o+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_o+yara_o+yue_x+yo_o+yori_o+wa_o+wake_x,
		wane_o+wayo_o+nn1_o+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_o+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_o+masu_x+masure_x,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nn2[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_o+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_x+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_o,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_o+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_x+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_o+wake_o,
		wane_o+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_o+desi_o+desho_o+desu_x+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	rasii[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_o+sae_x+si2_o+sika_x+sura_x+zutu_x+zo_o,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_o+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_o+wake_x,
		wane_o+wayo_o+nn1_o+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_o+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	drentai1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_o+kuseni_o+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_o+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_o+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_o,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_o+tokoro_o+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_o+node_o+noni_o,
		nomi_o+nominrz_o+ha_x+hazu_o+ba_x+bakari_o+he_x+hou_o,
		hoka_o+hodo_o+made_o+mama_o+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_o+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_o+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_o+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	drentai2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_o+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_o+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	drentai3[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_o+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_o+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	krentai[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_o+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_o+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_o+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_o+yo_x+yori_x+wa_x+wake_o,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	gotoki[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_o+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_o+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_o+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_o+yo_x+yori_x+wa_x+wake_o,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	beki[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_o+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_o+tokoro_o+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	souna1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	souna2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_o+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_o+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_o+hodo_o+made_o+mama_o+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_o+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_o+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	na2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_o+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	katei1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_o+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	katei2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_o,
		doori_x+dokoro_x+dokoroka_x+domo_o+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_o+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	katei3[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_o+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kamei[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_o,
		doori_x+dokoro_x+dokoroka_x+domo_o+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_o+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ike[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_o,
		doori_x+dokoro_x+dokoroka_x+domo_o+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_o+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_o+zunba_o+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kure[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_o+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_o,
		doori_x+dokoro_x+dokoroka_x+domo_o+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_o+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_o+zu_o+zunba_o+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_o+ne2_o+nn2_x+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	meirei1[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	meirei2[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	dgokan[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_o+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_o+desho_o+desu_o+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_o+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_o
	};
		
static	u_char	kgokan[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_o+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_o+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_o
	};
		
static	u_char	sgokan[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	gati[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_x+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_o+desho_o+desu_o+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	jya[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sou[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mitai[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	yotte[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	you2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sho[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	meisi[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_o+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_o+kuseni_x+kurai_o+gurumi_o+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_o+zo_o,
		tame_x+dake_o+dano_o+darake_o+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_o+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_o+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_o+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_o+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	wo_meisi[] = {
		wo_x+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_o+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_o+kuseni_x+kurai_o+gurumi_o+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_o+zo_o,
		tame_x+dake_o+dano_o+darake_o+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_o+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_o+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_o+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_o, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_o+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	dmeisi[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_o+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_o+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_o+zo_o,
		tame_x+dake_o+dano_o+darake_o+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_o+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_o+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_x+tagaru_x+taru_o+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_o+desho_o+desu_o+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_o
	};
		
static	u_char	smeisi1[] = {
		wo_x+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_o+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_o+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_o+gurumi_o+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_o+zo_o,
		tame_x+dake_o+dano_o+darake_o+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_o+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_o+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_o, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_o+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_o+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_o+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	smeisi2[] = {
		wo_x+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_o+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_o+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_o+zo_o,
		tame_x+dake_o+dano_o+darake_o+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_o+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_o+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_o, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_o+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_o+itadaku_o+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_o+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_o+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kstb[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_o+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_o+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ichisetubi[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_o+ppoi_o+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_x+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_o+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_o+zaru_o+zu_o+zunba_o+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_o+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_o,
		nu_o+ne2_o+nn2_o+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_o+you_o+youda_x+rasii_o+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_o+dekiru_x+naru_x+nasai_o+nasaru_o+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	josuusi[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_o+kuseni_x+kurai_o+gurumi_o+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_o+zo_o,
		tame_x+dake_o+dano_o+darake_o+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_o+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_o,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_o+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	rentaisi[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_o+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_o+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_o+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_o+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	cut[] = {	
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	shuujo[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	wo[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_o+kane_o+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_o+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	wo_s[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_o+kane_o+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_o+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_o+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	ttatte[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ttara[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tte1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tte2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ppanasi[] = {
		wo_o+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ppoi[] = {
		wo_x+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_o+kurai_o+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_o+sae_x+si2_o+sika_o+sura_x+zutu_x+zo_o,
		tame_o+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_o,
		te1_x+te2_x+teru_x+dearou_o+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_o+tokoro_o+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_o+nominrz_o+ha_x+hazu_o+ba_x+bakari_o+he_x+hou_o,
		hoka_o+hodo_o+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_o+wake_o,
		wane_o+wayo_o+nn1_o+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_x+desi_o+desho_o+desu_o+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ue[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	uti[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	oite[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	okeru[] = {	
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ori[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	ka1[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_x+he_o+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
		
static	u_char	ka2[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	katagata[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kadouka[] = {
		wo_o+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kamo[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kara1[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_x+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kara2[] = {
		wo_x+ttatte_o+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ga1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_o+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ga2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_o+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_o+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	gatera[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kiri[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_o+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kuseni[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kurai[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_o+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	gurumi[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kedo[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	koso[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	koto[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_o,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_o+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_o, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sae[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	si2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sika[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	sura[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	zutu[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_o+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_o+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tame[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_x+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_x+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tari[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_o+naru_x+nasai_o+nasaru_o+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	dake[] = {
		wo_o+ttatte_o+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_o+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	dano[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		

static	u_char	darake[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_o+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tuite[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_x+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tuki[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tutu[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_x+ari3_o+are1_x+are2_o,
		arou_o+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tumori[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	te1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	te2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_o+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_o+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_o+aru_o+ara_o+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_o+ii_o+itasi_x+itadaku_o+iru_o+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_o+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_o+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	teru[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_o,
		uti_o+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_o+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_o+kurai_o+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_o+sae_x+si2_o+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_o,
		te1_x+te2_x+teru_x+dearou_o+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_o+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_o+ba_x+bakari_o+he_x+hou_o,
		hoka_o+hodo_o+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_o+wake_o,
		wane_o+wayo_o+nn1_o+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_x,
		denbun_o+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_o+de_x+desi_x+desho_o+desu_x+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	to1[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_x+desi_o+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	to2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_x+kana_o+kane_o+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	totte[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	toiu[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_o+kana_x+kane_x+kamo_x+kara1_x+kara2_o+ga1_x,
		ga2_o+gatera_x+kiri_x+kuseni_o+kurai_o+gurumi_x+kedo_o+koso_x,
		koto_o+sa2_x+sae_x+si2_o+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_o,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_o+ne1_x+nee_x+no1_x+no2_o+node_o+noni_o,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_o+hodo_o+made_o+mama_x+mo1_x+mo2_x+motte_x+mono_o,
		ya1_x+ya2_x+yara_x+yue_o+yo_x+yori_x+wa_x+wake_o,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	toori[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	toki[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tokoro[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_x+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tote[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tohaie[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	tomo[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	fdo[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	doori[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	dokoro[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	dokoroka[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	domo[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nagara[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_x+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nagara2[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_x+yue_o+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	nazo[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_o+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nado[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nari[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_o+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nanka[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_o,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_o+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nanzo[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_o+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nante[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ni1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_o+okeru_o+ori_x+ka1_x+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_o+tuki_o+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_o,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_o+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_o+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_o+ii_x+itasi_x+itadaku_x+iru_o+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_x+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_o
	};
		
static	u_char	ni2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ni3[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_o,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nite[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nimo[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	no1[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_o+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_o+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_o+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_o+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_o+tokoro_o+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_o+mo1_o+mo2_x+motte_x+mono_o,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_o+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_o+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	no2[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_x+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	node[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_x+ari1_x+ari2_x+ari3_o+are1_x+are2_o,
		arou_o+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	noni[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nomi[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_o+yo_o+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nominrz[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ha[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_o+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_x+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	hazu[] = {
		wo_x+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_o+kane_o+kamo_x+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ba[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_o+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	bakari[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_o+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_o+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_o+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_o+ii_x+itasi_x+itadaku_x+iru_o+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	he[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	hou[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	hoka[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	hodo[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	made[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_o,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_o+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_o+ara_x+ari1_x+ari2_o+ari3_x+are1_x+are2_o,
		arou_o+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mama[] = {
		wo_o+ttatte_x+ttara_o+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_o,
		tame_x+dake_o+dano_o+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mo1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mo2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_o+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_o+sure_x+se_o+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	motte[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	mono[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_o+kara1_o+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_o+gurumi_x+kedo_x+koso_o,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_o,
		tame_x+dake_o+dano_o+darake_o+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_o+dokoroka_o+domo_x+na1_o+naa_o+nagara_o+nazo_o,
		nado_o+nari_o+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_o+nominrz_o+ha_o+hazu_x+ba_x+bakari_o+he_o+hou_x,
		hoka_x+hodo_o+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_o+ya2_x+yara_o+yue_x+yo_o+yori_o+wa_x+wake_x,
		wane_o+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_o+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ya1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	ya2[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	yara[] = {
		wo_o+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_o+sura_x+zutu_x+zo_x,
		tame_x+dake_o+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_o+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_o+hou_x,
		hoka_x+hodo_x+made_o+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_o+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	yue[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	yori1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	wake[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_o+kai_x+kasira_o,
		katagata_x+kadouka_o+kana_o+kane_o+kamo_x+kara1_x+kara2_x+ga1_o,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_o+to2_x+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_o+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_o+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	nn1[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_x+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	aisatu[] = {
		wo_o+ttatte_x+ttara_x+tte1_o+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_o+totte_x,
		toiu_o+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_o,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_o+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	kosodo[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_o+ka2_x+kai_x+kasira_o,
		katagata_x+kadouka_x+kana_o+kane_x+kamo_o+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_o+sae_o+si2_x+sika_o+sura_o+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_o,
		nado_o+nari_x+nanka_o+nanzo_o+nante_o+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_o+ne1_o+nee_o+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_o+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_o+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_o+daxtu_o,
		darou_o+de_o+desi_o+desho_o+desu_o+na2_o+nara_o+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_o+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_o+si1_o+siro_o,
		jyau_x+jimau_x+sugiru_x+subesi_o+suru_o+sure_o+se_o+seyo_o,
		tamau_x+tayu_x+timau_x+dekiru_o+naru_o+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};
		
static	u_char	site[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_x+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_x+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_x+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_x+tumori_x,
		te1_x+te2_x+teru_x+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_x+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_x+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_o+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_o+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_x+nagara2_x+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_x+youtai_x,
		denbun_x+ta_x+tai_x+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_x,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_x+masu_x+masure_x,
		mase_x+mitaida_x+you_x+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_x+itasi_x+itadaku_x+iru_x+eru_x+kakeru_x+kaneru_x,
		karazu_x+gatai_x+gatida_x+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_x+timau_x+dekiru_x+naru_x+nasai_x+nasaru_x+nikui_x,
		yasui_x+yoi_x+yaru_x+ttarasii_x
	};

static	u_char	n_si[] = {
		wo_x+ttatte_x+ttara_x+tte1_x+tte2_x+ppanasi_o+ppoi_x+ue_x,
		uti_x+oite_x+okeru_x+ori_x+ka1_x+ka2_x+kai_x+kasira_x,
		katagata_x+kadouka_x+kana_x+kane_x+kamo_x+kara1_x+kara2_x+ga1_x,
		ga2_x+gatera_o+kiri_x+kuseni_x+kurai_x+gurumi_x+kedo_x+koso_x,
		koto_x+sa2_x+sae_o+si2_x+sika_x+sura_x+zutu_x+zo_x,
		tame_x+dake_x+dano_x+darake_x+tuite_x+tuki_x+tutu_o+tumori_x,
		te1_x+te2_o+teru_o+dearou_x+deru_x+to1_x+to2_x+totte_x,
		toiu_x+toori_x+toki_x+tokoro_x+tote_x+tohaie_x+tomo_x+do_x,
		doori_x+dokoro_x+dokoroka_x+domo_x+na1_o+naa_x+nagara_x+nazo_x,
		nado_x+nari_x+nanka_x+nanzo_x+nante_x+ni1_x+ni2_o+ni3_x,
		nite_x+nimo_x+ne1_x+nee_x+no1_x+no2_x+node_x+noni_x,
		nomi_x+nominrz_x+ha_x+hazu_x+ba_x+bakari_x+he_x+hou_x,
		hoka_x+hodo_x+made_x+mama_x+mo1_x+mo2_x+motte_x+mono_x,
		ya1_x+ya2_x+yara_x+yue_x+yo_x+yori_x+wa_x+wake_x,
		wane_x+wayo_x+nn1_x+jya_x+tya_o+nagara2_o+wo_s_x, 
		ze_x+kke_x+n_si_x+deha_x,
		
		gotosi_x+saseru_x+zaru_x+zu_x+zunba_x+seru_x+souda_o+youtai_o,
		denbun_x+ta_o+tai_o+tagaru_x+taru_x+da1_x+da2_x+daxtu_x,
		darou_x+de_x+desi_x+desho_x+desu_x+na2_x+nara_x+nai_o,
		nu_x+ne2_x+nn2_x+fuuda_x+besi_x+mai_o+masu_o+masure_o,
		mase_x+mitaida_x+you_o+youda_x+rasii_x+rareru_x+reru_x+site_x,

		yougen_x+aru_x+ara_x+ari1_x+ari2_x+ari3_x+are1_x+are2_x,
		arou_x+ii_o+itasi_x+itadaku_x+iru_x+eru_x+kakeru_o+kaneru_o,
		karazu_x+gatai_o+gatida_o+kudasaru_x+gozai_x+sa1_x+si1_x+siro_x,
		jyau_x+jimau_x+sugiru_x+subesi_x+suru_x+sure_x+se_x+seyo_x,
		tamau_x+tayu_o+timau_x+dekiru_x+naru_x+nasai_o+nasaru_o+nikui_o,
		yasui_o+yoi_x+yaru_x+ttarasii_x
	};

u_char	connadr[] = {
		0,			
		R_MEISI,		
		R_MEISI,		
		R_MEISI,		
		R_MEISI,		
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		R_MEISI,		

		R_DAIMEISI,		
		R_DAIMEISI,		
		R_WO_MEISI,		
		0,			
		0,			
		R_DAIMEISI6,		

		0,			
		0,			
		0,	 		

		R_MEISI,		
		R_MEISI,		
		R_MEISI,		
		R_MEISI,		
		R_MEISI,		
		R_RENTAISI,		
		R_SETUZOKU,		
		R_KANDOU,		
		R_JOSUUSI,		
		R_SUUSI,		
		
		R_SETTOU,		
		R_SETTOU,		
		R_SETTOU,		
		R_SETTOU,		
		R_SETTOU,		

		R_MEISI,		
		R_MEISI,		
		R_MEISI,		
		R_MEISI,		
		0,			
		0,			
		0,			
		0,			
		R_MEISI,		

		R_FUKUSI,		
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		R_JOSUUSI,		

		0,			
		0,			
		0,			
		0,			
		0,		 	

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			

		0,			
		0,			

		0,			
		0,			
		0,			
		0,	  		
		0,			
		0,			
		0,			
		0,  			

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			

		0,			
		0,			

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			

		0,			
		0,			

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0, 			

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			

		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			

		R_MIZEN1,		
		R_MIZEN2,		
		R_SI1,			
		R_SHUUSI,		
		R_KATEI2,		
		R_MEIREI1,		
		R_MEIREI2,		
		R_KO,			
		R_KI,			
		R_SHUUSI,		
		R_KATEI2,		
		R_MEIREI1,		
		R_KUDASAI,		
		R_GOZAI,		
		R_ONBIN2,		
		R_KOSODO,		
		R_AISATU,		
		R_KSHUUSI,		
		R_TANKAN,		
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		0,			
		R_MEISI			
	};

u_char	*rigtadr[] = {
		0,		
		de,		
		wo,		
		kara1,		
		ga1,		
		to1,		
		ni1,		
		no1,		
		ha,		
		he,		
		mo1,		
		ya1,		
		yori1,		
		sae,		
		sika,		
		dake,		
		i,		
		e,		
		kake,		
		kane2,		
		sugi,		
		deki,		
		mi,		
		sase,		
		rare,		
		itadake,	
		exp,		
		renyou1,	
		renyou5,	
		sa5renyou1,	
		renyou3,	
		renyou7,	
		sa5renyou3,	
		renyou4,	
		renyou8,	
		sa5renyou4,	
		0,		
		0,		
		0,		
		krenyou,	
		drenyou1,	
		drenyou2,	
		drenyou3,	
		onbin1,		
		onbin2,		
		onbin3,		
		deshi,		
		axtu,		
		onbin6,		
		onbin8,		
		ari1,		
		ari2,		
		ari3,		
		iki,		
		itasi,		
		itadaki,	
		ori2,		
		gataku,		
		ki,		
		kudasai,	
		gozai,		
		gotoku,		
		beku,		
		soude,		
		souni,		
		tagari,		
		taku,		
		mizen1,		
		naide,		
		naku,		
		nasai,		
		fuuni,		
		yori2,		
		rashuu,		
		dshuusi1,	
		dshuusi2,	
		gotosi,		
		besi,		
		zu,		
		souda,		
		mai,		
		mitaida,	
		shuusi,		
		kshuusi,	
		zaru,		
		soudesu,	
		ta,		
		tai,		
		desu,		
		nai,		
		nu,		
		masu,		
		nn2,		
		rasii,		
		drentai1,	
		drentai2,	
		drentai3,	
		krentai,	
		gotoki,		
		beki,		
		souna1,		
		souna2,		
		na2,		
		katei1,		
		katei2,		
		katei3,		
		kamei,		
		ike,		
		kure,		
		meirei1,	
		meirei2,	
		dgokan,		
		kgokan,		
		sgokan,		
		gati,		
		jya,		
		sou,		
		mitai,		
		yotte,		
		you2,		
		sho,		
		meisi,		
		aisatu,		
		kosodo,		
		you1,		
		si1,		
		meisi,		
		meisi, 		
		fzkki,		
		deha,		
		nagara2,	
		wo_s,		
		wo_meisi,	
		site,		
		n_si,		
		cut,		
		0,		
		cut,		
		0, 0,		
		mizen2,		
		mizen3,		
		mizen4,		
		si1,		
		ji,		
		age,		
		mizen5,		
		arou,		
		karou,		
		darou,		
		deshou,		
		ko,		
		bekara,		
		tagara,		
		shuujo,		
		ttatte,		
		ttara,		
		tte1,		
		tte2,		
		ppanasi,	
		ppoi,		
		ue,		
		uti,		
		oite,		
		okeru,		
		ori,		
		ka1,		
		ka2,		
		katagata,	
		kadouka,	
		kamo,		
		kara2,		
		ga2,		
		gatera,		
		kiri,		
		kuseni,		
		kurai,		
		gurumi,		
		kedo,		
		koso,		
		koto,		
		si2,		
		sura,		
		zutu,		
		tame,		
		tari,		
		dano,		
		darake,		
		tuite,		
		tuki,		
		tutu,		
		tumori,		
		te1,		
		te2,		
		teru,		
		to2,		
		totte,		
		toiu,		
		toori,		
		toki,		
		tokoro,		
		tote,		
		tohaie,		
		tomo,		
		fdo,		
		doori,		
		dokoro,		
		dokoroka,	
		domo,		
		nagara,		
		nazo,		
		nado,		
		nari,		
		nanka,		
		nanzo,		
		nante,		
		ni2,		
		ni3,		
		nite,		
		nimo,		
		no2,		
		node,		
		noni,		
		nomi,		
		nominrz,	
		hazu,		
		ba,		
		bakari,		
		hou,		
		hoka,		
		hodo,		
		made,		
		mama,		
		mo2,		
		motte,		
		mono,		
		ya2,		
		yara,		
		yue,		
		wake,		
		nn1,		
		josuusi,	
		cut,		
		cut,		
		cut,		
		cut,		
		cut,		
		meisi,		
		dmeisi,		
		smeisi1,	
		smeisi2,	
		kstb,		
		ichisetubi,	
		josuusi,	
		rentaisi,	
		cut		
	};
